package
{
	import com.clementegomez.utils.XMLLoader;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.StyleSheet;
	import flash.text.TextFieldAutoSize;
	
	import gs.TweenLite;
	import gs.easing.*;

	public class DocumentClass extends MovieClip
	{
		private var xl:XMLLoader;
		private var dc:Namespace;
		private var currentFeed:String;
		private var currentPosition:Number;
		private var postLink:String;
		private var style:StyleSheet;
		
		public function DocumentClass()
		{
			dc = new Namespace("http://purl.org/dc/elements/1.1/");
			xl = new XMLLoader();
			style = new StyleSheet();
			style.setStyle(".description", {leading:10});
			style.setStyle(".title", {textDecoration:"underline"})
			xl.skipErrors = true;
			xl.cacheBuster = true;
			xl.addEventListener(Event.COMPLETE, xmlLoaded);
			xl.loadXML(["http://feeds2.feedburner.com/Flashden-DownTheFoxhole", "http://feeds2.feedburner.com/themeforest?format=xml", "http://feeds2.feedburner.com/AudiojungleBlog?format=xml", "http://feeds2.feedburner.com/Flashtuts?format=xml"],
				["flashDen", "themeForest", "audioJungle", "flashTuts"]);
			postTitle.field.autoSize = TextFieldAutoSize.LEFT;
			postDate.field.autoSize = TextFieldAutoSize.LEFT;
			postAuthor.field.autoSize = TextFieldAutoSize.LEFT;
			postTitle.field.styleSheet = style;
			postDesc.field.styleSheet = style;
		}
		
		private function xmlLoaded(e:Event):void
		{
			var length:Number = xl.data.length;
			for(var i:int = 0; i < length; i++)
			{
				var tab:MovieClip = new Tab();
				tab.x = 5;
				tab.y = i * (tab.height + 20) + 5;
				tab.alpha = 0;
				tab.name = xl.names[i];
				tab.buttonMode = true;
				tab.mouseChildren = false;
				tab.title.text = (xl.data[i] as XML).channel.title;
				stage.addChild(tab);
				tab.addEventListener(MouseEvent.CLICK, loadFeed);
				TweenLite.to(tab, .5, {alpha:1, delay: i *.25, ease:Strong.easeOut});
			}
			currentFeed = xl.names["flashDen"];
			next.buttonMode = true;
			prev.buttonMode = true;
			goto.buttonMode = true;
			next.addEventListener(MouseEvent.CLICK, buttonHandler);
			prev.addEventListener(MouseEvent.CLICK, buttonHandler);
			goto.addEventListener(MouseEvent.CLICK, buttonHandler);
			loadFeed(null, xl.names[0]);
		}
		
		private function loadFeed(e:MouseEvent = null, feed:String = null):void
		{
			(e) ? currentFeed = e.currentTarget.name : currentFeed = feed;
			currentPosition = 0;
			populate();
			rePosition(true);
		}
		
		private function buttonHandler(e:MouseEvent):void
		{
			switch(e.currentTarget.name)
			{
				case "next":
					(currentPosition >= (xl.data[currentFeed].channel.item as XMLList).length() - 1) ? currentPosition = 0 : currentPosition++;
					animate("out");
					break;
					
				case "prev":
					(currentPosition == 0) ? (xl.data[currentFeed].channel.item as XMLList).length() - 1 : currentPosition--;
					animate("out");
					break;
				
				case "goto":
					navigateToURL(new URLRequest(postLink), "_blank");
					break;
			}
		}
		
		private function populate($animate:Boolean = false):void
		{
			postTitle.field.htmlText = "<span class='title'>" + (xl.data[currentFeed] as XML).channel.item[currentPosition].title + "</span>";
			postDate.field.text = "Posted on: " +  String((xl.data[currentFeed] as XML).channel.item[currentPosition].pubDate).substring(0, 16);
			postDesc.field.htmlText = "<span class='description'>" + (xl.data[currentFeed] as XML).channel.item[currentPosition].description + "</span>";
			postAuthor.field.htmlText = "Written by: " + (xl.data[currentFeed] as XML).channel.item[currentPosition].dc::creator;
			postLink = (xl.data[currentFeed] as XML).channel.item[currentPosition].link;
			if($animate)
			{
				animate("in");
			}
		}
		
		private function animate(direction:String):void
		{
			if(direction == "in")
			{
				rePosition();
				TweenLite.to(postTitle, .5, {y:"-25", alpha:1, ease:Strong.easeOut});
				TweenLite.to(postDate, .5, {y:"-25", alpha:1, ease:Strong.easeOut});
				TweenLite.to(postDesc, .5, {y:"-25", alpha:1, ease:Strong.easeOut});
				TweenLite.to(postAuthor, .5, {x:"+50", alpha:1, ease:Strong.easeOut});
			}
			else if(direction == "out")
			{
				TweenLite.to(postTitle, .5, {y:"+25", alpha:0, ease:Strong.easeOut});
				TweenLite.to(postDate, .5, {y:"+25", alpha:0, ease:Strong.easeOut});
				TweenLite.to(postDesc, .5, {y:"+25", alpha:0, ease:Strong.easeOut});
				TweenLite.to(postAuthor, .5, {x:"-50", alpha:0, ease:Strong.easeOut, onComplete:populate, onCompleteParams:[true]});
			}
		}
		
		private function rePosition(firstLoad:Boolean = false):void
		{
			postDate.y = postTitle.y + postTitle.height + 10;
			postDesc.y = postDate.y + postDate.height + 25;
			if(firstLoad)
			{
				postTitle.y -= 25;
				postDate.y -= 25;
				postDesc.y -= 25;
				postAuthor.x += 50;
				postTitle.alpha = 0;
				postDate.alpha = 0;
				postDesc.alpha = 0;
				postAuthor.alpha = 0;
				TweenLite.to(postTitle, .5, {y:"+25", alpha:1, ease:Strong.easeOut});
				TweenLite.to(postDate, .5, {y:"+25", alpha:1, ease:Strong.easeOut});
				TweenLite.to(postDesc, .5, {y:"+25", alpha:1, ease:Strong.easeOut});
				TweenLite.to(postAuthor, .5, {x:"-50", alpha:1, ease:Strong.easeOut});
			}
		}
	}
}